# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataLakeAnalytics::Mgmt::V2016_11_01
  module Models
    #
    # The parameters that can be used to update an existing Data Lake Analytics
    # account.
    #
    class UpdateDataLakeAnalyticsAccountParameters

      include MsRestAzure

      # @return [Hash{String => String}] The resource tags.
      attr_accessor :tags

      # @return [Array<UpdateDataLakeStoreWithAccountParameters>] The list of
      # Data Lake Store accounts associated with this account.
      attr_accessor :data_lake_store_accounts

      # @return [Array<UpdateStorageAccountWithAccountParameters>] The list of
      # Azure Blob storage accounts associated with this account.
      attr_accessor :storage_accounts

      # @return [Array<UpdateComputePolicyWithAccountParameters>] The list of
      # compute policies associated with this account.
      attr_accessor :compute_policies

      # @return [Array<UpdateFirewallRuleWithAccountParameters>] The list of
      # firewall rules associated with this account.
      attr_accessor :firewall_rules

      # @return [FirewallState] The current state of the IP address firewall
      # for this account. Disabling the firewall does not remove existing
      # rules, they will just be ignored until the firewall is re-enabled.
      # Possible values include: 'Enabled', 'Disabled'
      attr_accessor :firewall_state

      # @return [FirewallAllowAzureIpsState] The current state of allowing or
      # disallowing IPs originating within Azure through the firewall. If the
      # firewall is disabled, this is not enforced. Possible values include:
      # 'Enabled', 'Disabled'
      attr_accessor :firewall_allow_azure_ips

      # @return [TierType] The commitment tier to use for next month. Possible
      # values include: 'Consumption', 'Commitment_100AUHours',
      # 'Commitment_500AUHours', 'Commitment_1000AUHours',
      # 'Commitment_5000AUHours', 'Commitment_10000AUHours',
      # 'Commitment_50000AUHours', 'Commitment_100000AUHours',
      # 'Commitment_500000AUHours'
      attr_accessor :new_tier

      # @return [Integer] The maximum supported jobs running under the account
      # at the same time.
      attr_accessor :max_job_count

      # @return [Integer] The maximum supported degree of parallelism for this
      # account.
      attr_accessor :max_degree_of_parallelism

      # @return [Integer] The maximum supported degree of parallelism per job
      # for this account.
      attr_accessor :max_degree_of_parallelism_per_job

      # @return [Integer] The minimum supported priority per job for this
      # account.
      attr_accessor :min_priority_per_job

      # @return [Integer] The number of days that job metadata is retained.
      attr_accessor :query_store_retention


      #
      # Mapper for UpdateDataLakeAnalyticsAccountParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'UpdateDataLakeAnalyticsAccountParameters',
          type: {
            name: 'Composite',
            class_name: 'UpdateDataLakeAnalyticsAccountParameters',
            model_properties: {
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              data_lake_store_accounts: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.dataLakeStoreAccounts',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UpdateDataLakeStoreWithAccountParametersElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'UpdateDataLakeStoreWithAccountParameters'
                      }
                  }
                }
              },
              storage_accounts: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.storageAccounts',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UpdateStorageAccountWithAccountParametersElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'UpdateStorageAccountWithAccountParameters'
                      }
                  }
                }
              },
              compute_policies: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.computePolicies',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UpdateComputePolicyWithAccountParametersElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'UpdateComputePolicyWithAccountParameters'
                      }
                  }
                }
              },
              firewall_rules: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.firewallRules',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UpdateFirewallRuleWithAccountParametersElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'UpdateFirewallRuleWithAccountParameters'
                      }
                  }
                }
              },
              firewall_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.firewallState',
                type: {
                  name: 'Enum',
                  module: 'FirewallState'
                }
              },
              firewall_allow_azure_ips: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.firewallAllowAzureIps',
                type: {
                  name: 'Enum',
                  module: 'FirewallAllowAzureIpsState'
                }
              },
              new_tier: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.newTier',
                type: {
                  name: 'Enum',
                  module: 'TierType'
                }
              },
              max_job_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.maxJobCount',
                constraints: {
                  InclusiveMinimum: 1
                },
                type: {
                  name: 'Number'
                }
              },
              max_degree_of_parallelism: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.maxDegreeOfParallelism',
                constraints: {
                  InclusiveMinimum: 1
                },
                type: {
                  name: 'Number'
                }
              },
              max_degree_of_parallelism_per_job: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.maxDegreeOfParallelismPerJob',
                constraints: {
                  InclusiveMinimum: 1
                },
                type: {
                  name: 'Number'
                }
              },
              min_priority_per_job: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.minPriorityPerJob',
                constraints: {
                  InclusiveMinimum: 1
                },
                type: {
                  name: 'Number'
                }
              },
              query_store_retention: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.queryStoreRetention',
                constraints: {
                  InclusiveMaximum: 180,
                  InclusiveMinimum: 1
                },
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
